#! /bin/sh

# Neuros OSD Internet Radio Player
# By wkrik@yahoo.com 7/08 v1.1
#
# This script will go to shoutcast, search the selected genre and
# display a list of stations to choose from. Once selected, it will
# clear your playlquee, add the station's URL and start streaming
# the station with xmms2 on your OSD.
#
# Required: wget
#

# Display how many stations
DISP=12

# The following should be fully qualified:

# TMP is a temp file that needs to be used.
TMP="/mnt/tmpfs/mount_USB/zSrc/iradio.tmp"
TMP="/tmp/iradio.tmp"

XMMS="/usr/local/bin/xmms2"
WGET="/mnt/tmpfs/mount_USB/zSrc/wget"

#XMMS="echo "
#WGET="/usr/bin/wget"
# 
# "list" is the list of menu items that is searched on shoutcast.
# add any genre that can be searched on shoutcast
# Syntax: menu_number:genre_search_pattern
#
list="
1:70s
2:80s
3:Ambient
4:Blues
5:Clasical
6:Jazz
7:Opera
8:Pop
9:Rock
10:Techno
"

#
# -------- START OF SCRIPT -------
#

stop_music()
{
  if [ "$STOP" = "s" ]; then
    echo; echo "  Stopping Music..."
    $XMMS stop &
    sleep 3
  fi
}


genre_menu()
{
  select="s"
  while [ "$select" = "s" ]
  do
  echo
  echo " Neuros OSD Internet Radio"
  echo " -------------------------"
  
  # GET THE LIST OF GENRE'S TO SELECT
  for line in $list
  do
    line=`echo $line | sed 's/:/ : /g' | sed 's/+/ /g'`
    echo "  $line" 
  done 
  
  echo; echo "  Select a 'GENRE', [s] to stop music,"
  echo -n "  or [enter] to exit:"
  read select
  if [ -z "$select" ]; then
    echo
    exit 0
  fi
  STOP="$select"; stop_music
  done

  for line in $list
  do
    gen=`echo $line | grep ^"${select}:" | cut -d":" -f2`
    if [ -n "$gen" ]; then
      break
    fi
  done
  echo
  echo "  $gen station selected..."
  echo
}


select_stations()
{
  leave=""
  while [ -z "$leave" ]
  do

  if [ ! -f "$TMP.$select" ]; then
    # GET THE AVAILABLE STATIONS FROM THE SELECTED GENRE
    echo -n "  Collecting $gen Stations...$"
      $WGET -qO $TMP "http://www.shoutcast.com/directory/index.phtml?numresult=${DISP}&sgenre=${gen}"
    echo -n "$"
    grep -E 'listlinks|tunein' $TMP > $TMP.new
    echo -n "$"
  
    rm $TMP
    cnt=-1
    x=0
    cat $TMP.new | while read line
    do
      if [ $x -eq 0 ]; then 
        URL=`echo $line | cut -d"=" -f4- | cut -d"\"" -f2- | cut -d"\"" -f1`
        URL="http://shoutcast.com$URL"
        x=1
        cnt=`expr $cnt + 1`
      else
        TTL=`echo $line | sed s/\<a/\~/ | cut -d"~" -f2- | cut -d">" -f2- | cut -d"<" -f1 | cut -c1-70`
     	if [ -z "$TTL" ]; then 
          cnt=`expr $cnt - 1`
        else
          echo "$cnt:$URL:$TTL" >> $TMP.$select
          echo -n "$"
        fi
        x=0
      fi
    done
    echo; echo
  fi

    cat $TMP.$select | cut -d":" -f1,4- | cut -c1-45
  
    # SELECT A STATION
    echo; echo -n "  Select a Station, [r] to Refresh or [enter] to go back:"
    read station
 
    if [ -z $station ]; then
      break
    fi
    STOP="$select"; stop_music

    if [ "$station" = "r" ]; then
      echo
      rm -f $TMP.$select
    else
     leave="yes"
    fi
  done
}


listen_station()
{
  if  [ -n "$station" ]; then
    LINE=`grep ^"${station}:" $TMP.$select`
    sURL=`echo $LINE | cut -d":" -f2-3`
    DESC=`echo $LINE | cut -d":" -f4-`
    
    #echo "$sURL  -- $DESC"
    $WGET -qO $TMP.pls "$sURL"
    
    
    pURL=`grep "File1=" $TMP.pls | cut -d"=" -f2-`
    
    echo
    echo "Starting Radio Station..."
      $XMMS stop
      $XMMS clear
      $XMMS add $pURL
      echo
      echo "*** PLAYING: $DESC"
      $XMMS play
      echo
  fi
    echo
    rm -f $TMP $TMP.new $TMP.pls 
}

while [ 1 ]
do
  genre_menu
  select_stations
  listen_station
done
exit 0
